/* apser.f -- translated by f2c (version 20100827).
with manual tuning by Michael Baudin (2012)
*/

#include <math.h>

#include "cdflib.h"
#include "cdflib_private.h" 

double cdflib_apser(double a, double b, double x, double eps)
{
	/* Initialized data */

	static double g = .577215664901533;

	/* System generated locals */
	double ret_val;

	/* Local variables */
	static double c__, j, s, t, aj, bx, tol;

	/* ----------------------------------------------------------------------- */
	/*     APSER YIELDS THE INCOMPLETE BETA RATIO I(SUB(1-X))(B,A) FOR */
	/*     A .LE. MIN(EPS,EPS*B), B*X .LE. 1, AND X .LE. 0.5. USED WHEN */
	/*     A IS VERY SMALL. USE ONLY IF ABOVE INEQUALITIES ARE SATISFIED. */
	/* ----------------------------------------------------------------------- */

	bx = b * x;
	t = x - bx;
	if (b * eps > .02) {
		goto L10;
	}
	c__ = log(x) + cdflib_psi1(b) + g + t;
	goto L20;
L10:
	c__ = log(bx) + g + t;

L20:
	tol = eps * 5. * fabs(c__);
	j = 1.;
	s = 0.;
L30:
	j += 1.;
	t *= x - bx / j;
	aj = t / j;
	s += aj;
	if (fabs(aj) > tol) {
		goto L30;
	}

	ret_val = -(a) * (c__ + s);
	return ret_val;
} /* cdflib_apser */

