// Copyright (C) 2012 - Michael Baudin
//
// This file must be used under the terms of the GNU Lesser General Public License license :
// http://www.gnu.org/copyleft/lesser.html

#include <math.h>
#include <stdio.h>

#include "cdflib.h" 
#include "cdflib_private.h" 

int cdflib_binopdf(double x, double n, double p, double * y)
{
	double q;
	int status;
    //
    // Check arguments
	status = cdflib_binCheckX("cdflib_binopdf", x, n);
	if (status!=CDFLIB_OK)
	{
		return ( status );
	}
	status = cdflib_binCheckParams("cdflib_binopdf", n, p);
	if (status!=CDFLIB_OK)
	{
		return ( status );
	}
    //
    // Perform
	q=1-p;
	*y = cdflib_binopdfraw(x, n, p, q, 0);
	return ( CDFLIB_OK );	
}

