// Copyright (C) 2012 - Michael Baudin
//
// This file must be used under the terms of the GNU Lesser General Public License license :
// http://www.gnu.org/copyleft/lesser.html

#include <math.h>
#include <stdio.h>

#include "cdflib.h" 
#include "cdflib_private.h" 

double cdflib_binopdfraw(double x,double n,double p,double q, int computelog)
{
    double y;
	double a;
	double b;
	double t;
	if (p==0)
	{
		if (x==0)
		{
			y = 1.;
		}
		else
		{
			y = 0.;
		}
		return y;
	}
	if (q==0)
	{
		if (x==n)
		{
			y = 1.;
		}
		else
		{
			y = 0.;
		}
		return y;
	}
	//
	a=x+1;
	b=n-x+1;
	t=cdflib_brcomp(a, b, p, q);
	y=t/(n+1)/p/q;
	if (computelog==CDFLIB_LOGCOMPUTE)
	{
		y=log(y);
	}
	return y;
}
