// Copyright (C) 2012 - Michael Baudin
//
// This file must be used under the terms of the GNU Lesser General Public License license :
// http://www.gnu.org/copyleft/lesser.html

#include <math.h>
#include <stdio.h>

#include "cdflib.h" 
#include "cdflib_private.h" 

// Computes the Chi-Square PDF
int cdflib_chi2pdf(double x, double k, double *y)
{
	int status;
	double a;
	a = k/2;
	//
	// Check arguments
	status = cdflib_chiCheckX("cdflib_chi2pdf",x);
	if (status!=CDFLIB_OK)
	{
		return status;
	}
	status = cdflib_chiCheckParams("cdflib_chi2pdf",k);
	if (status!=CDFLIB_OK)
	{
		return status;
	}
	status = cdflib_gammapdf(x,a,2.,y);
	return ( status );
}

