/* cumbet.f -- translated by f2c (version 20100827).
with manual tuning by Michael Baudin (2012)
  */

#include "cdflib.h"
#include "cdflib_private.h" 

/* Subroutine */ int cdflib_cumbet(double x, double y, double a, 
	double b, double *cum, double *ccum)
{
	static int ierr;

	/* ********************************************************************** */

	/*     SUBROUTINE CUMBET(X,Y,A,B,CUM,CCUM) */
	/*          Double precision cUMulative incomplete BETa distribution */


	/*                              Function */


	/*     Calculates the cdf to X of the incomplete beta distribution */
	/*     with parameters a and b.  This is the integral from 0 to x */
	/*     of (1/B(a,b))*f(t)) where f(t) = t**(a-1) * (1-t)**(b-1) */


	/*                              Arguments */


	/*     X --> Upper limit of integration. */


	/*     Y --> 1 - X. */


	/*     A --> First parameter of the beta distribution. */


	/*     B --> Second parameter of the beta distribution. */


	/*     CUM <-- Cumulative incomplete beta distribution. */


	/*     CCUM <-- Compliment of Cumulative incomplete beta distribution. */



	/*                              Method */


	/*     Calls the routine BRATIO. */

	/*                                   References */

	/*     Didonato, Armido R. and Morris, Alfred H. Jr. (1992) Algorithim */
	/*     708 Significant Digit Computation of the Incomplete Beta Function */
	/*     Ratios. ACM ToMS, Vol.18, No. 3, Sept. 1992, 360-373. */

	/* ********************************************************************** */

	if (x <= 0.) {
		*cum = 0.;
		*ccum = 1.;
		return 0;
	}
	if (y <= 0.) {
		*cum = 1.;
		*ccum = 0.;
		return 0;
	}
	cdflib_bratio(a, b, x, y, cum, ccum, &ierr);
	return 0;
}

