/* cumbin.f -- translated by f2c (version 20100827).
with manual tuning by Michael Baudin (2012)
  */

#include "cdflib.h"
#include "cdflib_private.h" 

/* Subroutine */ int cdflib_cumbin(double x, double xn, double pr, 
	double ompr, double *cum, double *ccum)
{
	/* System generated locals */
	double d__1, d__2;

	/* Local variables */

	/* ********************************************************************** */

	/*     SUBROUTINE CUMBIN(X,XN,PBIN,OMPR,CUM,CCUM) */
	/*                    CUmulative BINomial distribution */


	/*                              Function */


	/*     Returns the probability   of 0  to  X  successes in  XN   binomial */
	/*     trials, each of which has a probability of success, PBIN. */


	/*                              Arguments */


	/*     X --> The upper limit of cumulation of the binomial distribution. */


	/*     XN --> The number of binomial trials. */

	/*     PBIN --> The probability of success in each binomial trial. */

	/*     OMPR --> 1 - PBIN */

	/*     CUM <-- Cumulative binomial distribution. */

	/*     CCUM <-- Compliment of Cumulative binomial distribution. */


	/*                              Method */


	/*     Formula  26.5.24    of   Abramowitz  and    Stegun,  Handbook   of */
	/*     Mathematical   Functions (1966) is   used  to reduce the  binomial */
	/*     distribution  to  the  cumulative    beta distribution. */

	/* ********************************************************************** */

	if (x < xn) {
		d__1 = x + 1.;
		d__2 = xn - x;
		cdflib_cumbet(pr, ompr, d__1, d__2, ccum, cum);
		return 0;
	}
	*cum = 1.;
	*ccum = 0.;
	return 0;
}

