/* cumchi.f -- translated by f2c (version 20100827).
with manual tuning by Michael Baudin (2012)
  */

#include "cdflib.h"
#include "cdflib_private.h" 

/* Subroutine */ int cdflib_cumchi(double x, double df, double *cum, 
	double *ccum)
{
	static double a, xx;

	/* ********************************************************************** */

	/*     SUBROUTINE FUNCTION CUMCHI(X,DF,CUM,CCUM) */
	/*             CUMulative of the CHi-square distribution */


	/*                              Function */


	/*     Calculates the cumulative chi-square distribution. */


	/*                              Arguments */


	/*     X       --> Upper limit of integration of the */
	/*                 chi-square distribution. */


	/*     DF      --> Degrees of freedom of the */
	/*                 chi-square distribution. */


	/*     CUM <-- Cumulative chi-square distribution. */

	/*     CCUM <-- Compliment of Cumulative chi-square distribution. */


	/*                              Method */


	/*     Calls incomplete gamma function (CUMGAM) */

	/* ********************************************************************** */

	a = df * .5;
	xx = x * .5;
	cdflib_cumgam(xx, a, cum, ccum);
	return 0;
}

