/* cumgam.f -- translated by f2c (version 20100827).
with manual tuning by Michael Baudin (2012)
  */

#include "cdflib.h"
#include "cdflib_private.h" 

/* Subroutine */ int cdflib_cumgam(double x, double a, double *cum, 
	double *ccum)
{

	/* ********************************************************************** */

	/*     SUBROUTINE CUMGAM(X,A,CUM,CCUM) */
	/*           Double precision cUMulative incomplete GAMma distribution */


	/*                              Function */


	/*     Computes   the  cumulative        of    the     incomplete   gamma */
	/*     distribution, i.e., the integral from 0 to X of */
	/*          (1/GAM(A))*EXP(-T)*T**(A-1) DT */
	/*     where GAM(A) is the complete gamma function of A, i.e., */
	/*          GAM(A) = integral from 0 to infinity of */
	/*                    EXP(-T)*T**(A-1) DT */


	/*                              Arguments */


	/*     X --> The upper limit of integration of the incomplete gamma. */


	/*     A --> The shape parameter of the incomplete gamma. */


	/*     CUM <-- Cumulative incomplete gamma distribution. */


	/*     CCUM <-- Compliment of Cumulative incomplete gamma distribution. */


	/*                              Method */


	/*     Calls the routine GRATIO. */

	/* ********************************************************************** */

	if (x <= 0.) 
	{
		*cum = 0.;
		*ccum = 1.;
	}
	else
	{
		cdflib_gratio(a, x, cum, ccum, 0);
	}
	return 0;
}

