/* cumpoi.f -- translated by f2c (version 20100827).
with manual tuning by Michael Baudin (2012)
  */

#include "cdflib.h"
#include "cdflib_private.h" 

/* Subroutine */ int cdflib_cumpoi(double x, double xlam, double *cum, double *ccum)
{
	static double df, chi;

	/* ********************************************************************** */

	/*     SUBROUTINE CUMPOI(S,XLAM,CUM,CCUM) */
	/*                    CUMulative POIsson distribution */


	/*                              Function */


	/*     Returns the  probability  of  S   or  fewer events in  a   Poisson */
	/*     distribution with mean XLAM. */


	/*                              Arguments */


	/*     S --> Upper limit of cumulation of the Poisson. */


	/*     XLAM --> Mean of the Poisson distribution. */

	/*     CUM <-- Cumulative poisson distribution. */


	/*     CCUM <-- Compliment of Cumulative poisson distribution. */


	/*                              Method */


	/*     Uses formula  26.4.21   of   Abramowitz and  Stegun,  Handbook  of */
	/*     Mathematical   Functions  to reduce   the   cumulative Poisson  to */
	/*     the cumulative chi-square distribution. */

	/* ********************************************************************** */

	df = (x + 1.) * 2.;
	chi = xlam * 2.;
	cdflib_cumchi(chi, df, ccum, cum);
	return 0;
}

