/* cumt.f -- translated by f2c (version 20100827).
with manual tuning by Michael Baudin (2012)
  */

#include "cdflib.h"
#include "cdflib_private.h" 

/* Subroutine */ int cdflib_cumt(double x, double df, double *cum, double *ccum)
{
	/* System generated locals */
	double d__1;

	/* Local variables */
	static double a, tt, xx, yy, oma, dfptt;

	/* ********************************************************************** */

	/*                    CUMulative T-distribution */

	/*                              Function */

	/*     Computes the integral from -infinity to X of the t-density. */

	/*                              Arguments */


	/*     X --> Upper limit of integration of the t-density. */

	/*     DF --> Degrees of freedom of the t-distribution. */

	/*     CUM <-- Cumulative t-distribution. */

	/*     CCUM <-- Compliment of Cumulative t-distribution. */

	/*                              Method */

	/*     Formula 26.5.27   of     Abramowitz  and   Stegun,    Handbook  of */
	/*     Mathematical Functions  is   used   to  reduce the  t-distribution */
	/*     to an incomplete beta. */

	/* ********************************************************************** */

	tt = x * x;
	dfptt = df + tt;
	xx = df / dfptt;
	yy = tt / dfptt;
	d__1 = df * .5;
	cdflib_cumbet(xx, yy, d__1, .5, &a, &oma);
	if (x <= 0.) {
		*cum = a * .5;
		*ccum = oma + *cum;
	}
	else
	{
		*ccum = a * .5;
		*cum = oma + *ccum;
	}
	return 0;
}

