// Copyright (C) 2012 - Michael Baudin
//
// This file must be used under the terms of the GNU Lesser General Public License license :
// http://www.gnu.org/copyleft/lesser.html

#include <math.h>
#include <stdio.h>

#include "cdflib.h" 
#include "cdflib_private.h" 

// Normal PDF
int cdflib_normpdf(double x, double mu, double sigma, double *y)
{
	double lny;
	int status;
	// sq2pi = sqrt(2.0*pi)
	double sq2pi = 2.50662827463100020;
	double z;
	//
	// Check arguments
	status=cdflib_norCheckX("cdflib_normpdf",x);
	if (status!=CDFLIB_OK)
	{
		return status;
	}
	status=cdflib_norCheckParams("cdflib_normpdf",mu, sigma);
	if (status!=CDFLIB_OK)
	{
		return status;
	}
	//
	z = ( x - mu ) / sigma;
	lny = - 0.5 * z * z - log(sigma * sq2pi);
	*y = exp ( lny );
	return ( CDFLIB_OK );
}

