/* rcomp.f -- translated by f2c (version 20100827).
with manual tuning by Michael Baudin (2012)
*/

#include <math.h>

#include "cdflib.h"
#include "cdflib_private.h" 

double cdflib_rcomp(double a, double x)
{
	/*     ------------------- */
	/*     EVALUATION OF EXP(-X)*X**A/GAMMA(A) */
	/*     ------------------- */

	/* Initialized data */

	/*     ------------------- */
	/*     RT2PIN = 1/SQRT(2*PI) */
	/*     ------------------- */
	static double rt2pin = .398942280401433;

	/* System generated locals */
	double ret_val, d__1;

	/* Local variables */
	static double t, u, t1;

	ret_val = 0.;
	if (a >= 20.) {
		goto L20;
	}
	t = a * log(x) - x;
	if (a >= 1.) {
		goto L10;
	}
	ret_val = a * exp(t) * (cdflib_gam1(a) + 1.);
	return ret_val;
L10:
	ret_val = exp(t) / cdflib_gamma(a);
	return ret_val;

L20:
	u = x / a;
	if (u == 0.) {
		return ret_val;
	}
	/* Computing 2nd power */
	d__1 = 1. / a;
	t = d__1 * d__1;
	t1 = (((t * .75 - 1.) * t + 3.5) * t - 105.) / (a * 1260.);
	t1 -= a * cdflib_rlog(u);
	ret_val = rt2pin * sqrt(a) * exp(t1);
	return ret_val;
}

