/* spmpar.f -- translated by f2c (version 20100827).
with manual tuning by Michael Baudin (2012)
*/

#include "cdflib.h"
#include "cdflib_private.h" 

/* ----------------------------------------------------------------------- */
/*     SPMPAR PROVIDES THE DOUBLE PRECISION MACHINE CONSTANTS FOR */
/*     THE COMPUTER BEING USED. IT IS ASSUMED THAT THE ARGUMENT */
/*     I IS AN INTEGER HAVING ONE OF THE VALUES 1, 2, OR 3. IF THE */
/*     SINGLE PRECISION ARITHMETIC BEING USED HAS M BASE B DIGITS AND */
/*     ITS SMALLEST AND LARGEST EXPONENTS ARE EMIN AND EMAX, THEN */

/*        SPMPAR(1) = B**(1 - M), THE MACHINE PRECISION, */

/*        SPMPAR(2) = B**(EMIN - 1), THE SMALLEST MAGNITUDE, */

/*        SPMPAR(3) = B**EMAX*(1 - B**(-M)), THE LARGEST MAGNITUDE. */

/* ----------------------------------------------------------------------- */
double cdflib_spmpar(int i)
{
	/* System generated locals */
	double ret_val;

	/* Local variables */

	switch (i) {
	case 1:  
		{
			// B**(1 - M), THE MACHINE PRECISION
			//ret_val = dlamch_("p", (long int)1);
			ret_val = 2.2204460492503131e-016;
			break;
		}
	case 2: 
		{
			// B**(EMIN - 1), THE SMALLEST MAGNITUDE
			// ret_val = dlamch_("u", (long int)1);
			ret_val = 2.2250738585072014e-308;
			break;
		}
	case 3:  
		{
			// B**EMAX*(1 - B**(-M)), THE LARGEST MAGNITUDE
			// ret_val = dlamch_("o", (long int)1);
			ret_val = 1.7976931348623157e+308;
			break;
		}
	default:
		{
			cdflib_messageprint ( "cdflib(spmpar): called with wrong argument" );
			ret_val = 0.;
			break;
		}
	}
	return ret_val;
}

