/* genrand_gennf.f -- translated by f2c (version 20100827).
with manual tuning by Michael Baudin (2012)
*/

#include <math.h>

#include "genrand.h"
#include "genrand_private.h"

double genrand_gennf(double dfn, double dfd, double xnonc)
{
	double ret_val, d__1, d__2;

	static int io;
	static float wte;
	static double xden, xnum;

	/*     JJV changed the code to call genrand_sgamma and genrand_snorm directly */
	/*      DOUBLE PRECISION genrand_genchi,genrand_gennch */
	/*      EXTERNAL genrand_genchi,genrand_gennch */
	/*     .. */
	/*     .. Executable Statements .. */
	/*     JJV changed the argument checker to allow DFN = 1.0 */
	/*     JJV in the same way as genrand_gennch was changed. */
	/*      genrand_gennf = ( genrand_gennch( DFN, XNONC ) / DFN ) / ( genrand_genchi( DFD ) / DFD ) */
	/*     JJV changed this to call genrand_sgamma and genrand_snorm directly */
	/*     xnum = genrand_gennch(dfn,xnonc)/dfn */
	if (dfn >= 1.000001f) {
		goto L20;
	}
	/*     JJV case dfn = 1.0 - here I am treating dfn as exactly 1.0 */
	/* Computing 2nd power */
	d__1 = genrand_snorm() + sqrt(xnonc);
	xnum = d__1 * d__1;
	goto L30;
	/*     JJV case dfn > 1.0 */
L20:
	d__1 = (dfn - 1.f) / 2.f;
	/* Computing 2nd power */
	d__2 = genrand_snorm() + sqrt(xnonc);
	xnum = (genrand_sgamma(d__1) * 2.f + d__2 * d__2) / dfn;
	/*     xden = genrand_genchi(dfd)/dfd */
L30:
	d__1 = dfd / 2.f;
	xden = genrand_sgamma(d__1) * 2.f / dfd;
	/*     JJV changed constant so that it will not underflow at compile time */
	/*     JJV while not slowing generator by using double precision or logs. */
	/*      IF (.NOT. (xden.LE. (1.0E-38*xnum))) GO TO 40 */
	if (! (xden <= xnum * 1e-37f)) {
		goto L40;
	}
	genrand_messageprint("Noncentral F Random Number: Generated numbers would cause overflow");
	/*     JJV next 2 lines changed to maintain truncation of large deviates. */
	/*      WRITE (*,*) ' genrand_gennf returning 1.0E38' */
	/*      genrand_gennf = 1.0E38 */
	genrand_messageprint("Noncentral F Random Number: Returning 1.0E37");
	ret_val = 1e37f;
	goto L50;
L40:
	ret_val = xnum / xden;
L50:
	return ret_val;
}

