// Copyright (C) Bruno Pincon (<Bruno.Pincon@iecn.u-nancy.fr>)
// Copyright (C) 2012 - Michael Baudin
#include <math.h>
#include "genrand.h"
#include "genrand_private.h"

double genrand_igngeom(double p)
{
	static double p_save = 1.0, ln_1_m_p = 0.0;
	double u;
	double R;

	if ( p == 1 ) 
	{
		return ( 1.0 );
	}
	else if ( p != p_save )   /* => recompute log(1-p) */
	{
		p_save = p; 
		u = -p; 
		ln_1_m_p = genrand_logp1(u);
	};

	u = -genrand_randgenerate();
	R = floor( genrand_logp1(u)/ln_1_m_p);
	return ( R );
}      

